<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, minimum-scale=1, initial-scale=1, user-scalable=yes">

    <title>dez-canvas test</title>

    <script src="../../webcomponentsjs/webcomponents-lite.js"></script>
    <script src="../../web-component-tester/browser.js"></script>

    <script src="../bower_components/Snap.svg/dist/snap.svg-min.js"></script>
    <script src="../lib/snap/SnapView.js"></script>
    <script src="../lib/Background.js"></script>
    <script src="../lib/CanvasView.js"></script>

  </head>
  <body>

    <script>

    suite('CanvasView', () => {

        suite ('->changeHeightIfNeeded', () => {

            setup (() => {
                this.canvasView = new CanvasView(new SnapView())
                this.DEFAULT_HEIGHT = 200
            })

            test ('should increase if given value is higher than height', () => {
                this.canvasView.changeHeightIfNeeded(600)
                assert.equal(this.canvasView.height, 600)
            })

            test ('should reduce if given value is smaller than height', () => {
                this.canvasView.changeHeightIfNeeded(100)
                assert.equal(this.canvasView.height, 100)
            })

            test ('should not change height if given value is smaller than height and bg is set', async () => {
                await this.canvasView.setBackground("../demo/magritte.jpg")
                this.canvasView.changeHeightIfNeeded(100)
                assert.equal(this.canvasView.height, 300)
            })

        })

        suite('->setBackground', () => {

            setup (() => {
                this.canvasView = new CanvasView(new SnapView())
            })

            test ('should fit to image height', async () => {
                await this.canvasView.setBackground("../demo/magritte.jpg")
                assert.equal(this.canvasView.height, 300)
            })

            test ('should not change height if bg is undefined', async () => {
                await this.canvasView.setBackground()
                assert.equal(this.canvasView.height, 200)
            })

            test ('should not change height if bg src is bad', async () => {
                await this.canvasView.setBackground("bad/src")
                assert.equal(this.canvasView.height, 200)
            })

        })

    });

    </script>

  </body>
</html>
